package xstartup.base;

import xstartup.base.exception.XServiceException;
import xstartup.base.util.XUuidUtils;

/**
 * @author lixueyan
 * @date 2023/4/4 0004 13:36
 * 为满足定时任务等 非前端请求需要用户信息的 接口，特创建此类
 */
public class XSelfServiceContext extends XContext {

    XSelfServiceContext(String logTag) {
        super(XUuidUtils.randomUUID(), "UNKNOWN", XStartup.getCurrent().getScope(), logTag);
    }

    public static XSelfServiceContext build(String logTag) {
        XSelfServiceContext context = new XSelfServiceContext(logTag);
        return context;
    }

    public static XSelfServiceContext build(Class<?> targetClass) {
        XSelfServiceContext context = new XSelfServiceContext(targetClass.getName());
        return context;
    }

    public XApp getApp() {
        if (this.app == null) {
            XAppInfo appInfo = XStartup.getApplication();
            this.app = new XApp(appInfo.getSystemId(), appInfo.getTenantId(), appInfo.getId());
        }

        return this.app;
    }

    public XUser getUser() {
        if (this.user == null) {
            this.user = XUser.createAnonymousUser("local", 1L, 1L, 1L, "xservice", "xservice");
        }

        return this.user;
    }

    public void setUser(XUser user) throws XServiceException {
        this.user = user;
    }

    public String getSessionId() {
        return this.getUser().getSessionId();
    }
}