package pps.cloud.system.service;

import pps.cloud.system.service.data.sys_organization.*;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.data.XListResult;
import xstartup.data.XSingleResult;

@XText("组织机构服务")
@XService
public interface SysOrganizationCloudService {

    @XText("根据id获取组织机构详情")
    XSingleResult<GetSysOrganizationViewOutput> getSysOrganizationById(XContext context, GetSysOrganizationViewInput input);

    @XText("根据用户id获取组织机构")
    XSingleResult<GetSysOrganizationViewOutput> getOuByUserId(XContext context, GetSysOrganizationViewInput input);

    @XText("根据组织机构ids获取组织机构")
    XListResult<GetOuListTreeOutput> getOuListByOuIds(XContext context, GetOuListByOuIdsInput input);

    @XText("根据组织机构id获取所有的子级组织机构列表")
    XListResult<GetSysOrganizationViewOutput> getAllListByOuId(XContext context, GetAllOuListByOuIdInput input);

    @XText("查采油厂列表")
    XListResult<GetSysOrganizationViewOutput> getPlantList(XContext context);
}

