package pps.core.system.cache;

import xstartup.base.XContext;
import xstartup.cache.XCacheLife;
import xstartup.cache.XCacheObject;
import xstartup.cache.XSingleCache;

public class LoginVerCodeCache implements XCacheObject, XCacheLife {
    private String codeKey;
    private String code;

    /**
     * 检查缓存是否存在指定的code
     *
     * @param context
     * @param code
     * @return
     */
    public static LoginVerCodeCache exist(XContext context, String code) {
        LoginVerCodeCache isExist = LoginVerCodeCache.Tool.get(LoginVerCodeCache.Tool.class).find(context, code, LoginVerCodeCache.class);
        return isExist;
    }

    /**
     * 设置缓存
     *
     * @param context
     * @param cache
     */
    public static void set(XContext context, LoginVerCodeCache cache) {
        LoginVerCodeCache.Tool.get(LoginVerCodeCache.Tool.class).set(context, cache);
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getCodeKey() {
        return codeKey;
    }

    public void setCodeKey(String codeKey) {
        this.codeKey = codeKey;
    }

    @Override
    public Integer getDuration() {
        return 3 * 60;
    }

    @Override
    public String getCacheKey() {
        return this.codeKey;
    }

    static class Tool extends XSingleCache<LoginVerCodeCache> {
        @Override
        protected LoginVerCodeCache restore(XContext context, String cacheKey) {
            return null;
        }
    }
}
