package pps.core.system.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.system.entity.SysOrganizationRelEnt;
import pps.core.system.entity.SysOrganizationRelView;
import pps.core.system.mapper.SysOrganizationRelMapper;
import pps.core.system.mapper.SysOrganizationRelViewMapper;
import pps.core.system.service.data.sys_organization_rel.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SysOrganizationRelService {

    @XApiPost
    public XServiceResult createSysOrganizationRel(XContext context, CreateSysOrganizationRelInput input) {
        SysOrganizationRelMapper mapper = context.getBean(SysOrganizationRelMapper.class);
        SysOrganizationRelEnt entity = new SysOrganizationRelEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiPost
    public XServiceResult deleteSysOrganizationRel(XContext context, DeleteSysOrganizationRelInput input) {
        SysOrganizationRelMapper mapper = context.getBean(SysOrganizationRelMapper.class);
        QueryWrapper<SysOrganizationRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SysOrganizationRelEnt::getId, input.getId());
        SysOrganizationRelEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiGet
    public XSingleResult<GetSysOrganizationRelOutput> getSysOrganizationRel(XContext context, GetSysOrganizationRelInput input) {
        SysOrganizationRelMapper mapper = context.getBean(SysOrganizationRelMapper.class);
        QueryWrapper<SysOrganizationRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SysOrganizationRelEnt::getId, input.getId());
        SysOrganizationRelEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSysOrganizationRelOutput output = new GetSysOrganizationRelOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiGet
    public XPageResult<QuerySysOrganizationRelOutput> querySysOrganizationRel(XContext context, QuerySysOrganizationRelInput input) {
        SysOrganizationRelMapper mapper = context.getBean(SysOrganizationRelMapper.class);
        QueryWrapper<SysOrganizationRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SysOrganizationRelEnt::getId, input.getId())
                .like(SysOrganizationRelEnt::getOuId, input.getOuId())
                .like(SysOrganizationRelEnt::getParentOuId, input.getParentOuId())
                .eq(SysOrganizationRelEnt::getLevels, input.getLevels())
                .like(SysOrganizationRelEnt::getOuIdPath, input.getOuIdPath())
                .eq(SysOrganizationRelEnt::getIsHasChildren, input.getIsHasChildren())
                .eq(SysOrganizationRelEnt::getEffectTime, input.getEffectTime())
                .eq(SysOrganizationRelEnt::getEndTime, input.getEndTime())
                .eq(SysOrganizationRelEnt::getSort, input.getSort())
                .like(SysOrganizationRelEnt::getCreateById, input.getCreateById())
                .like(SysOrganizationRelEnt::getCreateByName, input.getCreateByName())
                .eq(SysOrganizationRelEnt::getCreateTime, input.getCreateTime())
                .like(SysOrganizationRelEnt::getModifyById, input.getModifyById())
                .like(SysOrganizationRelEnt::getModifyByName, input.getModifyByName())
                .eq(SysOrganizationRelEnt::getModifyTime, input.getModifyTime());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySysOrganizationRelOutput.class);
    }

    @XApiGet
    public XPageResult<QuerySysOrganizationRelOutput> dynamicQuerySysOrganizationRel(XContext context, CustomQueryInput input) {
        SysOrganizationRelMapper mapper = context.getBean(SysOrganizationRelMapper.class);
        return XMapperHelper.query(mapper, input, SysOrganizationRelEnt.class, QuerySysOrganizationRelOutput.class);
    }

    @XApiGet
    public XSingleResult<GetSysOrganizationRelViewOutput> getSysOrganizationRelView(XContext context, GetSysOrganizationRelViewInput input) {
        SysOrganizationRelViewMapper mapper = context.getBean(SysOrganizationRelViewMapper.class);
        SysOrganizationRelView record = new SysOrganizationRelView();
        XCopyUtils.copyObject(input, record);
        SysOrganizationRelView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSysOrganizationRelViewOutput output = new GetSysOrganizationRelViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiGet
    public XPageResult<QuerySysOrganizationRelViewOutput> querySysOrganizationRelView(XContext context, QuerySysOrganizationRelViewInput input) {
        SysOrganizationRelViewMapper mapper = context.getBean(SysOrganizationRelViewMapper.class);
        SysOrganizationRelView record = new SysOrganizationRelView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SysOrganizationRelView> list = mapper.selectList(record);
        PageInfo<SysOrganizationRelView> pageInfo = new PageInfo<>(list);
        List<QuerySysOrganizationRelViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySysOrganizationRelViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }
}