package pps.core.system.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.system.entity.SysUserGroupRoleRelEnt;
import pps.core.system.entity.SysUserGroupRoleRelView;
import pps.core.system.mapper.SysUserGroupRoleRelMapper;
import pps.core.system.mapper.SysUserGroupRoleRelViewMapper;
import pps.core.system.service.data.sys_user_group_role_rel.*;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XText("用户组和角色关系")
@XService
public class SysUserGroupRoleRelService {
    @XApiPost
    public XServiceResult createSysUserGroupRoleRel(XContext context, CreateSysUserGroupRoleRelInput input) {
        SysUserGroupRoleRelMapper mapper = context.getBean(SysUserGroupRoleRelMapper.class);
        SysUserGroupRoleRelEnt entity = new SysUserGroupRoleRelEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiPost
    public XServiceResult updateSysUserGroupRoleRel(XContext context, UpdateSysUserGroupRoleRelInput input) {
        SysUserGroupRoleRelMapper mapper = context.getBean(SysUserGroupRoleRelMapper.class);
        QueryWrapper<SysUserGroupRoleRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SysUserGroupRoleRelEnt::getId, input.getId());
        SysUserGroupRoleRelEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiPost
    public XServiceResult deleteSysUserGroupRoleRel(XContext context, DeleteSysUserGroupRoleRelInput input) {
        SysUserGroupRoleRelMapper mapper = context.getBean(SysUserGroupRoleRelMapper.class);
        QueryWrapper<SysUserGroupRoleRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SysUserGroupRoleRelEnt::getId, input.getId());
        SysUserGroupRoleRelEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiPost
    public XSingleResult<GetSysUserGroupRoleRelOutput> getSysUserGroupRoleRel(XContext context, GetSysUserGroupRoleRelInput input) {
        SysUserGroupRoleRelMapper mapper = context.getBean(SysUserGroupRoleRelMapper.class);
        QueryWrapper<SysUserGroupRoleRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SysUserGroupRoleRelEnt::getId, input.getId());
        SysUserGroupRoleRelEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSysUserGroupRoleRelOutput output = new GetSysUserGroupRoleRelOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiPost
    public XPageResult<QuerySysUserGroupRoleRelOutput> querySysUserGroupRoleRel(XContext context, QuerySysUserGroupRoleRelInput input) {
        SysUserGroupRoleRelMapper mapper = context.getBean(SysUserGroupRoleRelMapper.class);
        QueryWrapper<SysUserGroupRoleRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SysUserGroupRoleRelEnt::getId, input.getId())
                .like(SysUserGroupRoleRelEnt::getRoleId, input.getRoleId())
                .like(SysUserGroupRoleRelEnt::getUserGroupId, input.getUserGroupId())
                .like(SysUserGroupRoleRelEnt::getCreateById, input.getCreateById())
                .like(SysUserGroupRoleRelEnt::getCreateByName, input.getCreateByName())
                .eq(SysUserGroupRoleRelEnt::getCreateTime, input.getCreateTime())
                .like(SysUserGroupRoleRelEnt::getModifyById, input.getModifyById())
                .like(SysUserGroupRoleRelEnt::getModifyByName, input.getModifyByName())
                .eq(SysUserGroupRoleRelEnt::getModifyTime, input.getModifyTime());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySysUserGroupRoleRelOutput.class);
    }

    @XApiPost
    public XPageResult<QuerySysUserGroupRoleRelOutput> dynamicQuerySysUserGroupRoleRel(XContext context, CustomQueryInput input) {
        SysUserGroupRoleRelMapper mapper = context.getBean(SysUserGroupRoleRelMapper.class);
        return XMapperHelper.query(mapper, input, SysUserGroupRoleRelEnt.class, QuerySysUserGroupRoleRelOutput.class);
    }

    @XApiPost
    public XSingleResult<GetSysUserGroupRoleRelViewOutput> getSysUserGroupRoleRelView(XContext context, GetSysUserGroupRoleRelViewInput input) {
        SysUserGroupRoleRelViewMapper mapper = context.getBean(SysUserGroupRoleRelViewMapper.class);
        SysUserGroupRoleRelView record = new SysUserGroupRoleRelView();
        XCopyUtils.copyObject(input, record);
        SysUserGroupRoleRelView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSysUserGroupRoleRelViewOutput output = new GetSysUserGroupRoleRelViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XText("根据用户组id查询选中的角色")
    @XApiPost
    public XPageResult<QuerySysUserGroupRoleRelViewOutput> querySysUserGroupRoleRelView(XContext context, QuerySysUserGroupRoleRelViewInput input) {
        SysUserGroupRoleRelViewMapper mapper = context.getBean(SysUserGroupRoleRelViewMapper.class);
        SysUserGroupRoleRelView record = new SysUserGroupRoleRelView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SysUserGroupRoleRelView> list = mapper.selectList(record);
        PageInfo<SysUserGroupRoleRelView> pageInfo = new PageInfo<>(list);
        List<QuerySysUserGroupRoleRelViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySysUserGroupRoleRelViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }
}