package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import pps.core.base.entity.BasePhotovoltaicPlantEnt;
import pps.core.base.entity.BasePhotovoltaicPlantMapeAdjEnt;
import pps.core.base.entity.BasePhotovoltaicPlantMapeAdjView;
import pps.core.base.mapper.BasePhotovoltaicPlantMapeAdjMapper;
import pps.core.base.mapper.BasePhotovoltaicPlantMapeAdjViewMapper;
import pps.core.base.mapper.BasePhotovoltaicPlantMapper;
import pps.core.base.service.data.base_photovoltaic_plant_mape_adj.CreateBasePhotovoltaicPlantMapeAdjInput;
import pps.core.base.service.data.base_photovoltaic_plant_mape_adj.GetBasePhotovoltaicPlantMapeAdjInput;
import pps.core.base.service.data.base_photovoltaic_plant_mape_adj.GetBasePhotovoltaicPlantMapeAdjOutput;
import pps.core.common.entity.BaseModel;
import pps.core.common.session.PpsUserSession;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.feature.api.annotation.XApiPost;

import java.math.BigDecimal;
import java.util.Date;

@XText("光伏功率预测准确率调整相关操作")
@XService
public class BasePhotovoltaicPlantMapeAdjService {

    @XText("保存数据")
    @XApiPost
    public XServiceResult saveData(XContext context, CreateBasePhotovoltaicPlantMapeAdjInput input) {
        BasePhotovoltaicPlantMapeAdjMapper mapper = context.getBean(BasePhotovoltaicPlantMapeAdjMapper.class);
        BasePhotovoltaicPlantMapeAdjEnt ent = XCopyUtils.copyNewObject(input, BasePhotovoltaicPlantMapeAdjEnt.class);
        if (ent.getMapePlusVal() == null) ent.setMapePlusVal(BigDecimal.ZERO);
        PpsUserSession session = context.getSession(PpsUserSession.class);
        Date date = new Date();
        if (input.getId() == null) {
            ent.setCreateById(session.getId());
            ent.setCreateByName(session.getUserName());
            ent.setCreateTime(date);
            mapper.insert(ent);
        } else {
            ent.setModifyById(session.getId());
            ent.setModifyByName(session.getUserName());
            ent.setModifyTime(date);
            mapper.updateById(ent);
        }
        return XServiceResult.OK;
    }

    @XText("获取调整数据")
    @XApiPost
    public XSingleResult<GetBasePhotovoltaicPlantMapeAdjOutput> getData(XContext context, GetBasePhotovoltaicPlantMapeAdjInput input) {
        GetBasePhotovoltaicPlantMapeAdjOutput output = new GetBasePhotovoltaicPlantMapeAdjOutput();
        //获取电站信息
        BasePhotovoltaicPlantMapper basePhotovoltaicPlantMapper = context.getBean(BasePhotovoltaicPlantMapper.class);
        BasePhotovoltaicPlantEnt basePhotovoltaicPlantEnt = basePhotovoltaicPlantMapper.selectOne(new LambdaQueryWrapper<BasePhotovoltaicPlantEnt>()
                .eq(BaseModel::getId, input.getPlantId()));
        if (basePhotovoltaicPlantEnt == null) return XSingleResult.error(500, "未查找到电站信息");

        BasePhotovoltaicPlantMapeAdjViewMapper mapper = context.getBean(BasePhotovoltaicPlantMapeAdjViewMapper.class);
        BasePhotovoltaicPlantMapeAdjView record = new BasePhotovoltaicPlantMapeAdjView();
        XCopyUtils.copyObject(input, record);
        BasePhotovoltaicPlantMapeAdjView view = mapper.selectOne(record);
        if (view == null) {
            output.setPlantName(basePhotovoltaicPlantEnt.getStationName());
            output.setMapePlusVal(BigDecimal.ZERO);
            return XSingleResult.success(output);
        }
        XCopyUtils.copyObject(view, output);
        output.setPlantName(basePhotovoltaicPlantEnt.getStationName());
        return XSingleResult.success(output);
    }

    @XText("重置调整数据")
    @XApiPost
    public XServiceResult resetData(XContext context, GetBasePhotovoltaicPlantMapeAdjInput input) {
        BasePhotovoltaicPlantMapeAdjMapper mapper = context.getBean(BasePhotovoltaicPlantMapeAdjMapper.class);
        PpsUserSession session = context.getSession(PpsUserSession.class);
        BasePhotovoltaicPlantMapeAdjEnt ent = new BasePhotovoltaicPlantMapeAdjEnt();
        ent.setMapePlusVal(BigDecimal.ZERO);
        ent.setModifyById(session.getId());
        ent.setModifyByName(session.getUserName());
        ent.setModifyTime(new Date());
        UpdateWrapper<BasePhotovoltaicPlantMapeAdjEnt> ur = new UpdateWrapper<>();
        ur.lambda().eq(BasePhotovoltaicPlantMapeAdjEnt::getPlantId, input.getPlantId()).eq(BasePhotovoltaicPlantMapeAdjEnt::getMapeType, input.getMapeType());
        mapper.update(ent, ur);
        return XServiceResult.OK;
    }

}
