package pps.core.space.mapper;

import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;
import pps.core.space.entity.LineDailyElectricityTrendView;

import java.util.List;

/**
 * 线路日用电趋势
 *
 * @author ZWT
 * @date 2024/05/22
 */
@Repository(value = "pps.core.space.mapper.LineDailyElectricityTrendViewMapper")
public interface LineDailyElectricityTrendViewMapper {
    /**
     * 选择一个
     *
     * @param record 记录
     * @return {@link LineDailyElectricityTrendView }
     */
    LineDailyElectricityTrendView selectOne(LineDailyElectricityTrendView record);

    /**
     * 选择列表
     *
     * @param record 记录
     * @return {@link List }<{@link LineDailyElectricityTrendView }>
     */
    List<LineDailyElectricityTrendView> selectList(LineDailyElectricityTrendView record);

    /**
     * 批量插入
     *
     * @param list 列表
     * @return int
     */
    int batchInsert(@Param(value = "list") List<LineDailyElectricityTrendView> list);

    /**
     * 用电趋势统计
     *
     * @param record 记录
     * @return {@link List }<{@link LineDailyElectricityTrendView }>
     */
    List<LineDailyElectricityTrendView> selectDailyElectricityTrend(LineDailyElectricityTrendView record);
}
