package pps.core.prediction.service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import pps.cloud.prediction.service.PlantTrainPowerTaskCloudService;
import pps.cloud.prediction.service.data.plant_train_power_task.GetPlantTrainPowerTaskCloudInput;
import pps.cloud.prediction.service.data.plant_train_power_task.GetPlantTrainPowerTaskCloudOutput;
import pps.core.prediction.entity.PlantTrainPowerTaskEnt;
import pps.core.prediction.mapper.PlantTrainPowerTaskMapper;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XSingleResult;

@XService
public class PlantTrainPowerTaskService implements PlantTrainPowerTaskCloudService {
    @Override
    public XSingleResult<GetPlantTrainPowerTaskCloudOutput> getPlantTrainPowerTaskData(XContext context, GetPlantTrainPowerTaskCloudInput input) {
        PlantTrainPowerTaskMapper mapper = context.getBean(PlantTrainPowerTaskMapper.class);
        LambdaQueryWrapper<PlantTrainPowerTaskEnt> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(PlantTrainPowerTaskEnt::getPlantId, input.getPlantId())
                .eq(PlantTrainPowerTaskEnt::getModelCycle, input.getModelCycle())
                .eq(PlantTrainPowerTaskEnt::getRunState, 1)
                .eq(PlantTrainPowerTaskEnt::getRunStep, "model_train")
                .orderByDesc(PlantTrainPowerTaskEnt::getCreateTime)
                .last("limit 1");
        PlantTrainPowerTaskEnt ent = mapper.selectOne(queryWrapper);
        if (ent == null) {
            queryWrapper.clear();
            queryWrapper.eq(PlantTrainPowerTaskEnt::getModelKey, "all_plant_data")
                    .eq(PlantTrainPowerTaskEnt::getModelCycle, input.getModelCycle())
                    .eq(PlantTrainPowerTaskEnt::getRunState, 1)
                    .eq(PlantTrainPowerTaskEnt::getRunStep, "model_train")
                    .orderByDesc(PlantTrainPowerTaskEnt::getCreateTime)
                    .last("limit 1");
            ent = mapper.selectOne(queryWrapper);
        }
        GetPlantTrainPowerTaskCloudOutput output = XCopyUtils.copyNewObject(ent, GetPlantTrainPowerTaskCloudOutput.class);
        return XSingleResult.success(output);
    }
}