package pps.core.prediction.service;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import pps.core.prediction.entity.ThirdActivePowerEnt;
import pps.core.prediction.mapper.ThirdActivePowerMapper;
import pps.core.prediction.service.data.plant_predicted_power_mid_term.GetPlantPredictedPowerMidTermOutput;
import xstartup.base.XContext;
import xstartup.base.util.XDateUtils;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;


public class ThirdActivePowerServiceHelper {
    public static void getActivePower(XContext context, List<GetPlantPredictedPowerMidTermOutput> outputs, String plantId, Date showTime) {
        ThirdActivePowerMapper mapper = context.getBean(ThirdActivePowerMapper.class);
        List<ThirdActivePowerEnt> powerList = mapper.selectList(new LambdaQueryWrapper<ThirdActivePowerEnt>()
                .eq(ThirdActivePowerEnt::getStationId, plantId)
                .ge(ThirdActivePowerEnt::getCreateDate, XDateUtils.addDays(new Date(), -2))
        );
        if (powerList.size() > 0) {
            outputs.forEach(item -> {
                if (item.getPower() == null && XDateUtils.compare(XDateUtils.parse(item.getDataDate()), new Date()) < 0) {
                    Date targetDate = XDateUtils.parse(item.getDataDate());
                    Date closeDate = powerList.get(0).getCreateDate();
                    BigDecimal photovoltaicPower = powerList.get(0).getPhotovoltaicPower();
                    for (ThirdActivePowerEnt power : powerList) {
                        if (Math.abs(power.getCreateDate().getTime() - targetDate.getTime())
                                < Math.abs(closeDate.getTime() - targetDate.getTime())) {
                            closeDate = power.getCreateDate();
                            photovoltaicPower = power.getPhotovoltaicPower();
                        }
                    }
                    item.setPower(photovoltaicPower);
                }
            });
        }
    }
}