package app;

import pps.core.task.job.*;
import xstartup.base.XStartup;
import xstartup.base.conf.XServerConf;
import xstartup.base.conf.XServiceConf;
import xstartup.boot.XStartupApplication;
import xstartup.feature.XJobFeature;
import xstartup.feature.api.XApiFeature;
import xstartup.feature.api.conf.XApiCookieConf;
import xstartup.feature.cors.XCorsFeature;
import xstartup.feature.mybatis.XMybatisFeature;
import xstartup.feature.rpc.XRpcFeature;
import xstartup.feature.swagger.XSwaggerFeature;
import xstartup.service.job.conf.XJobServiceConf;


public class DeployPpsAllApplication {
    public static void main(String... args) {
        XStartup startup = new XStartupApplication("pps");
        startup.config(new XServerConf(22060).naming("pps-all"));
        startup.config(new XServiceConf("pps"));
        startup.enable(XApiFeature.class)
                .config(new XApiCookieConf("%4bH8s9&", 900));
        startup.enable(XSwaggerFeature.class);
        startup.enable(XMybatisFeature.class);
        startup.enable(XRpcFeature.class);
        startup.enable(XCorsFeature.class);
        startup.enable(XJobFeature.class).config(new XJobServiceConf(SpaceOptimizeLongJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(SpaceOptimizeMidJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(SpaceCalibrationJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(SpaceOptimizeUltraJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(SpaceOptimizeShortJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(PlantPredictedPowerLongTermDataJob.class));
        startup.run(args);
    }
}
